/*
 * JBoss, Home of Professional Open Source
 * Copyright 2013, Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */

package org.richfaces.demo.tables.model.expenses;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ExpenseReportRecord {
    private String city;
    private List<ExpenseReportRecordItem> items = new ArrayList<ExpenseReportRecordItem>();

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public List<ExpenseReportRecordItem> getItems() {
        return this.items;
    }

    public void setItems(List<ExpenseReportRecordItem> items) {
        this.items = items;
    }

    public double getTotalMeals() {
        double ret = 0.0;
        Iterator<ExpenseReportRecordItem> it = items.iterator();
        while (it.hasNext()) {
            ExpenseReportRecordItem item = (ExpenseReportRecordItem) it.next();
            ret += item.getMeals();
        }
        return ret;
    }

    public double getTotalHotels() {
        double ret = 0.0;
        Iterator<ExpenseReportRecordItem> it = items.iterator();
        while (it.hasNext()) {
            ExpenseReportRecordItem item = (ExpenseReportRecordItem) it.next();
            ret += item.getHotels();
        }
        return ret;
    }

    public double getTotalTransport() {
        double ret = 0.0;
        Iterator<ExpenseReportRecordItem> it = items.iterator();
        while (it.hasNext()) {
            ExpenseReportRecordItem item = (ExpenseReportRecordItem) it.next();
            ret += item.getTransport();
        }
        return ret;
    }

    public double getTotal() {
        return getTotalMeals() + getTotalHotels() + getTotalTransport();
    }

    public int getItemsCount() {
        return getItems().size();
    }
}
